#include	<stdio.h>
#include	<math.h>
#include	<stdlib.h>

#define		EPS		1.0e-2

void    simp1(a, mm, ll, nll, iabf, kp, bmax)
float   **a;
int     mm;
int     *ll;
int     nll;
int     iabf;
int     *kp;
float   *bmax;
{
 int    k;
 float  test;

  *kp = ll[1];
  *bmax = a[mm+1][*kp+1];

  for (k=2; k<=nll; k++) {
    if (iabf == 0)
      test = a[mm+1][ll[k]+1]-(*bmax);
    else
      test = fabs(a[mm+1][ll[k]+1])-fabs(*bmax);
    if (test > 0.0) {
      *bmax = a[mm+1][ll[k]+1];
      *kp = ll[k];
    }
  }
  printf("simp 1 : bmax=%f kp=%d nll=%d mm=%d  %2d\n",*bmax, *kp, nll, mm, iabf);
  if (*kp == 31) printf("** %f **\n",a[mm+1][23]);
}

void    simp2(a, n, l2, nl2, ip, kp, q1)
float   **a;
int     n;
int     *l2;
int     nl2;
int     *ip;
int     kp;
float   *q1;
{
 int    k, ii, i;
 float  qp, q0, q;

  printf("simp 2\n");

  *ip = 0;
  for (i=1; i<=nl2; i++) {
    if (a[l2[i]+1][kp+1] < -EPS) {
      *q1 = -a[l2[i]+1][1]/a[l2[i]+1][kp+1];
      *ip = l2[i];
      for (i=i+1; i<=nl2; i++) {
        ii = l2[i];
        if (a[ii+1][kp+1] < -EPS) {
          q = -a[ii+1][1]/a[ii+1][kp+1];
          if (q < *q1) {
            *ip = ii;
            *q1 = q;
          } else if (q == *q1) {
                   for (k=1; k<=n; k++) {
                     qp = -a[*ip+1][k+1]/a[*ip+1][kp+1];
                     q0 = -a[ii+1][k+1]/a[ii+1][kp+1];
                     if (q0 != qp) break;
                   }
                   if (q0 < qp) *ip = ii;
                 }
        }
      }
    }
  }
  printf("SIMP 2 : n=%d nl2=%d ip=%d kp=%d q1=%f\n",n,nl2,*ip,kp,*q1);
}

void    simp3(a, i1, k1, ip, kp)
float   **a;
int     i1, k1, ip, kp;
{
 int    kk, ii;
 float  piv;

  piv = 1.0/a[ip+1][kp+1];
  for (ii=1; ii<=i1+1; ii++)
    if ((ii-1) != ip) {
      a[ii][kp+1] *= piv;
      for (kk=1; kk<=k1+1; kk++)
        if ((kk-1) != kp)
          a[ii][kk] -= (a[ip+1][kk]*a[ii][kp+1]);
    }

  for (kk=1; kk<=k1+1; kk++)
    if ((kk-1) != kp) a[ip+1][kk] *= (-piv);
  a[ip+1][kp+1] = piv;

  printf("simp 3 : i1=%d k1=%d ip=%d kp=%d %f\n",i1,k1,ip,kp,a[i1+1][1]);

}

void    simplx(a, m, n, m1, m2, m3, icase, izrov, iposv)
float   **a;
int     m, n, m1, m2, m3;
int     *icase;
int     *izrov, *iposv;
{
 int    i, ip, ir, is, k, kh, kp, m12, nl1, nl2;
 int    *l1, *l2, *l3;
 float  q1, bmax;

  if (m != (m1+m2+m3)) {
    printf("Bad input constraint counts in simplx\n");
    exit();
  }
  l1 = (int *) malloc((size_t) ((n+2)*sizeof(int)));
  l2 = (int *) malloc((size_t) ((m+1)*sizeof(int)));
  l3 = (int *) malloc((size_t) ((m+1)*sizeof(int)));
  nl1 = n;
  for (k=1; k<=n; k++)
    l1[k] = izrov[k] = k;
  nl2 = m;
  for (i=1; i<=m; i++) {
    if (a[i+1][1] < 0.0) {
      printf("Bad input tableau in simplx\n");
      free(l1);
      free(l2);
      free(l3);
      exit();
    }
    l2[i] = i;
    iposv[i] = n+i;
  }

  for (i=1; i<=m2; i++) l3[i] = 1;
  ir = 0;

  if (m2+m3) {
    ir = 1;
    for (k=1; k<=n+1; k++) {
      q1 = 0.0;
      for (i=m1+1; i<=m; i++)
        q1 += a[i+1][k];
      a[m+2][k] = -q1;
    }
   do {
    simp1(a,m+1,l1,nl1,0,&kp,&bmax);

    if ((bmax <= EPS) && (a[m+2][1] < -EPS)) {
      *icase = -1;
      free(l1);
      free(l2);
      free(l3);
      return;
    } else if ((bmax <= EPS) && (a[m+2][1] <= EPS)) {
             m12 = m1+m2+1;
             if (m12 <= m) {
               for (ip=m12; ip<=m; ip++) {
                 if (iposv[ip] == (ip+n)) {
                   simp1(a,ip,l1,nl1,1,&kp,&bmax);
                   if (bmax > 0.0) goto one;
                 }
               }
             }
               ir = 0;
               --m12;
               if ((m1+1) <= m12)
                 for (i=m1+1; i<=m12; i++)
                   if (l3[i-m1] == 1)
                     for (k=1; k<=n+1; k++)
                       a[i+1][k] = -a[i+1][k];
               break;
           }
    simp2(a,n,l2,nl2,&ip,kp,&q1);
    if (ip == 0) {
      *icase = -1;
      free(l1);
      free(l2);
      free(l3);
      return;
    }

one:
      simp3(a,m+1,n,ip,kp);

printf("simp 3 --- 0\n"); 

      if (iposv[ip] >= (n+m1+m2+1)) {
        for (k=1; k<=nl1; k++)
          if (l1[k] == kp) break;
        --nl1;
        for (is=k; is<=nl1; is++)
          l1[is] = l1[is+1];
        ++a[m+2][kp+1];
        for (i=1; i<=m+2; i++)
          a[i][kp+1] = -a[i][kp+1];
      }
      else {
        if (iposv[ip] >= (n+m1+1)) {

printf("simp 3 --- 1\n"); 

          kh = iposv[ip]-m1-n;
          if (l3[kh]) {
            l3[kh] = 0;
            ++a[m+2][kp+1];
            for (i=1; i<=m+2; i++)
              a[i][kp+1] = -a[i][kp+1];
          }
        }
      }
      is = izrov[kp];
      izrov[kp] = iposv[ip];
      iposv[ip] = is;
   } while (ir);
  }

  for (;;) {
    simp1(a,0,l1,nl1,0,&kp,&bmax);
    if (bmax <= 0.0) {
      *icase = 0;
      free(l1);
      free(l2);
      free(l3);
      return;
    }
    simp2(a,n,l2,nl2,&ip,kp,&q1);
    if (ip == 0) {
      *icase = 1;
      free(l1);
      free(l2);
      free(l3);
      return;
    }
    simp3(a,m,n,ip,kp);
    is = izrov[kp];
    izrov[kp] = iposv[ip];
    iposv[ip] = is;
  }
}

void 	main()
{
 float	**a; 
 int	n, m, m1, m2, m3, icase;
 int	*izrov, *iposv;
 int	i, j, k;
 FILE	*fid;

  fid = fopen("input.dat","r");
  fscanf(fid,"%d%d%d%d%d",&n,&m,&m1,&m2,&m3);

  a = (float **) malloc((m+3)*sizeof(float *));
  for (i=0; i<m+3; i++)
    a[i] = (float *) malloc((n+2)*sizeof(float));
  izrov = (int *) malloc((n+1)*sizeof(int));
  iposv = (int *) malloc((m+1)*sizeof(int));

  for (i=1; i<m+3; i++)
    for (j=1; j<n+2; j++)
      fscanf(fid,"%f",&a[i][j]);

  fclose(fid);
/*
  for (i=1; i<m+3; i++) {
    for (j=1; j<n+2; j++)
      printf("%f ",a[i][j]);
    printf("\n");
  }
*/
  simplx(a,m,n,m1,m2,m3,&icase,izrov,iposv);

  if (icase == 0) printf("Sloutions are found\n\n");
/*
  if (icase == 0) {
    printf("Sloutions are found\n\n");
    for (i=1; i<m+3; i++) {
      for (j=1; j<n+2; j++) 
        printf("%4f ",a[i][j]);
      printf("\n");
    }
    printf("izrov : \n");
    for (i=1; i<n+1; i++)
      printf("%3d ",izrov[i]);
    printf("\n");
    printf("iposv : \n");
    for (i=1; i<m+1; i++)
      printf("%3d ",iposv[i]);
    printf("\n");
  }
  else {
    printf("Unbounded value or no solution ! case : %d!\n",icase);
  }
*/
  for (i=1; i<=m; i++)
    if ((iposv[i] <= n/2) && (a[i+1][1] > 0))
      printf("%5d  %f\n",iposv[i],a[i+1][1]);

  free(izrov);
  free(iposv);
  for (i=0; i<m+3; i++)
    free(a[i]);
  free(a);
}

